import 'dart:async';

abstract class StorageInterface {
  StorageInterface(this.fileName, [this.path]);

  final String path, fileName;

  Stream<Map<String, dynamic>> get stream;

  StreamSubscription<Map<String, dynamic>> listen(
      void onData(Map<String, dynamic> event),
      {Function onError,
      void onDone(),
      bool cancelOnError});

  StreamController<Map<String, dynamic>> storage;

  void dispose() {
    storage.close();
  }

  Future<void> init([Map<String, dynamic> initialData]);

  Future<void> write(String key, dynamic value);

  dynamic read(String key);

  Future<bool> exists();

  Future<void> clear();

  Future<void> remove(String key);

  Future<void> flush();
}
